#ifndef _IMPR_HELPERS_H_
#define _IMPR_HELPERS_H_

#include <stdint.h>
#include <stdio.h>


/* helpers */
#ifndef min
/* signedness is important because of sign extending shift */
static inline int min(int a, int b)
{
	int t = (a-b) >> (sizeof(a)*8-1);
	return (a&t) | (b&~t);
}
#endif

#ifndef max
/* !! max(INT_MIN, 0) does not work right !! */
static inline int max(int a, int b)
{
	int t = (a-b) >> (sizeof(a)*8-1);
	return (b&t) | (a&~t);
}
#endif

#ifndef absi
static inline int absi(int a)
{
	int t = a >> (sizeof(a)*8-1);
	return (a+t) ^ t;
}
#endif

#endif /* _IMPR_HELPERS_H_ */
