#ifndef _FILTER_H_
#define _FILTER_H_

#include "impr.h"

void filter_roberts_thresh(b8 *dest, u8 *src, int w, int h, int thresh);
void filter_smooth_2(u8 *dest, u8 *src, int w, int h);

/* following ones are deprecated */
void filter_roberts(u8 *dest, u8 *src, int w, int h);
void filter_roberts_add(u8 *dest, u8 *src, int w, int h);

void filter_sobel(u8 *dest, u8 *src, int w, int h);
void filter_sobel_add(u8 *dest, u8 *src, int w, int h);

void filter_laplace(u8 *dest, u8 *src, int w, int h);
void filter_laplace_add(u8 *dest, u8 *src, int w, int h);

void filter_smooth_x(u8 *dest, u8 *src, int w, int h, int size);

#endif
